require 'display_triangle.rb'
require 'pattern_canvas.rb'


# --------------------------------------------------

graphic = MYGLWindowViewTriangle.new(800, 600, "preview")


case 0
when 0
  # --- test1 - full cross
  p1 = PPoint.new(-1.0, -0.6, 0)
  p2 = PPoint.new( 0.2,  0.7, 0)
  p3 = PPoint.new( 0.9, -0.5, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 1
  # --- test2 - 1in 1cross
  p1 = PPoint.new(-1.0, -0.8, 0)
  p2 = PPoint.new( 0.2,  0.7, 0)
  p3 = PPoint.new( 0.9, -0.9, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 2
  # --- test3 - 1in 1in (tri2 subdivision)
  p1 = PPoint.new(-1.0, -0.8, 0)
  p2 = PPoint.new( 0.2,  0.3, 0)
  p3 = PPoint.new( 0.9, -0.9, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 3
  # --- test4 - 1in 1in (tri2 subdivision) part2
  p1 = PPoint.new(-1.0, -0.8, 0)
  p2 = PPoint.new( 0.5,  0.3, 0)
  p3 = PPoint.new( 0.9, -0.9, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 4
  # --- test5 - 1in 1in (tri2 subdivision) part3
  p1 = PPoint.new(-1.0, -0.8, 0)
  p2 = PPoint.new(-0.5,  0.3, 0)
  p3 = PPoint.new( 0.9, -0.9, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 5
  # --- test6 - 2in 1in (tri2 subdivision x2)
  p1 = PPoint.new(-0.3, -0.8, 0)
  p2 = PPoint.new(-0.5,  0.3, 0)
  p3 = PPoint.new( 0.4,  0.1, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 6
  # --- test7 - tri1 across
  p1 = PPoint.new(-0.3, -0.8, 0)
  p2 = PPoint.new(-0.5,  0.8, 0)
  p3 = PPoint.new( 0.4,  0.7, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 7
  # --- test8 - 1top match
  p1 = PPoint.new(-0.3, -0.8, 0)
  p2 = PPoint.new(-0.5,  0.8, 0)
  p3 = PPoint.new( 0.8,  0.5, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 8
  # --- test9 - 2top match
  p1 = PPoint.new(-0.3, -0.8, 0)
  p2 = PPoint.new(-0.7,  0.4, 0)
  p3 = PPoint.new( 0.8,  0.5, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
when 9
  # --- test10 - 3top match
  p1 = PPoint.new( 0.2, -0.7, 0)
  p2 = PPoint.new(-0.7,  0.4, 0)
  p3 = PPoint.new( 0.8,  0.5, 0)
  p4 = PPoint.new( 0.8,  0.5, 0)
  p5 = PPoint.new( 0.2, -0.7, 0)
  p6 = PPoint.new(-0.7,  0.4, 0)
end



#
tri1 = PTriangle.new
tri1.set_point(0, p1)
tri1.set_point(1, p2)
tri1.set_point(2, p3)
tri1.normalize
tri2 = PTriangle.new
tri2.set_point(0, p4)
tri2.set_point(1, p5)
tri2.set_point(2, p6)
tri2.normalize

#
graphic.clear_object()
#  graphic.add_object(tri1)
#  graphic.add_object(tri2)

canvas = PatternCanvas.new

divide = TriangleCollision.new(tri1)
divide.divide_crossline(tri2)

chunk1 = divide.div1
chunk2 = divide.div2
printf("div1 = %d\n", chunk1.size)
printf("div2 = %d\n", chunk2.size)
chunk1.each do |tri|
  graphic.add_object(tri)
end
chunk2.each do |tri|
  graphic.add_object(tri)
end

graphic.running
